Note: This is a public test instance of Red Hat Bugzilla. The data contained within is a snapshot of the live data so any changes you make will not be reflected in the production Bugzilla. Email is disabled so feel free to test any aspect of the site that you want. File any problems you find or give feedback at bugzilla.redhat.com.

Bug 2140295

Summary: Review Request: python-formulaic - A high-performance implementation of Wilkinson formulas
Product: [Fedora] Fedora Reporter: Ankur Sinha (FranciscoD) <sanjay.ankur>
Component: Package ReviewAssignee: fedepell <fede>
Status: CLOSED RAWHIDE QA Contact: Fedora Extras Quality Assurance <extras-qa>
Severity: unspecified Docs Contact:
Priority: unspecified    
Version: rawhideCC: fede, package-review
Target Milestone: ---Flags: fede: fedora-review+
Target Release: ---   
Hardware: Unspecified   
OS: Unspecified   
Whiteboard: Trivial
Fixed In Version: Doc Type: If docs needed, set a value
Doc Text:
Story Points: ---
Clone Of: Environment:
Last Closed: 2022-11-10 09:15:18 UTC Type: ---
Regression: --- Mount Type: ---
Documentation: --- CRM:
Verified Versions: Category: ---
oVirt Team: --- RHEL 7.3 requirements from Atomic Host:
Cloudforms Team: --- Target Upstream Version:
Embargoed:
Bug Depends On:    
Bug Blocks: 1276941    

Description Ankur Sinha (FranciscoD) 2022-11-05 11:53:53 UTC
Spec URL: https://ankursinha.fedorapeople.org/python-formulaic/python-formulaic.spec
SRPM URL: https://ankursinha.fedorapeople.org/python-formulaic/python-formulaic-0.5.2-2.fc38.src.rpm

Description:
Formulaic is a high-performance implementation of Wilkinson formulas for
Python.

It provides:

- high-performance dataframe to model-matrix conversions.
- support for reusing the encoding choices made during conversion of one
  data-set on other datasets.
- extensible formula parsing.
- extensible data input/output plugins, with implementations for:
  - input:
    - pandas.DataFrame
    - pyarrow.Table
  - output:
    - pandas.DataFrame
    - numpy.ndarray
    - scipy.sparse.CSCMatrix
- support for symbolic differentiation of formulas (and hence model matrices).

Fedora Account System Username: ankursinha

Comment 1 Ankur Sinha (FranciscoD) 2022-11-05 11:53:55 UTC
This package built on koji:  https://koji.fedoraproject.org/koji/taskinfo?taskID=93820943

Comment 2 fedepell 2022-11-09 05:59:42 UTC
Hello!
Looks mostly all fine!

Minor comments:

-) Dependencie just wonderign: you added sympy which is an optional, but not pyarrow which is the other optional, is there a reason for this?

> BuildRequires:  python3-sympy

Just another side note on dependencies: due to "python3dist(typing-extensions) >= 4.2" this will only build with FC37 or higher. And of course depending if you release interface-meta (and its dependencies) in FC37 in the future :-)

-) Add license file explicitly that is missing? So add under %files:

> %license LICENSE

-) I read the comments on the disabled tests and the upstream thread. I saw they were just recently fixed here: https://github.com/matthewwardrop/formulaic/commit/e5dedcb0feed39f5ff6e2326d727ca65d247f26d
Would it be worth to add this patch (to be removed at next package update) so then we can run all the tests probably?

Comment 3 Ankur Sinha (FranciscoD) 2022-11-09 11:31:02 UTC
Thanks very much for the review fedepell :)

(In reply to fedepell from comment #2)
> Hello!
> Looks mostly all fine!
> 
> Minor comments:
> 
> -) Dependencie just wonderign: you added sympy which is an optional, but not
> pyarrow which is the other optional, is there a reason for this?
> 
> > BuildRequires:  python3-sympy

They should ideally all be pulled in automatically. sympy was required for one of the tests and wasn't pulled in, so I've added it manually there. pyarrow was not required for the tests from the looks of it.

> 
> Just another side note on dependencies: due to
> "python3dist(typing-extensions) >= 4.2" this will only build with FC37 or
> higher. And of course depending if you release interface-meta (and its
> dependencies) in FC37 in the future :-)

I intend to push the deps to all releases---they're in side tags at the moment, but yes, if the necessary version of typing-extensions isn't in Fedora=<37, we won't be able to build this package there. I can ask the maintainers if they'd consider updating, but going from 3.x to 4.x is a major update, so they may not want to do that in Fedora<=37 :(

> 
> -) Add license file explicitly that is missing? So add under %files:
> 
> > %license LICENSE

In this one, the pyproject macros mark the LICENSE file already, so we don't need to do it again:

rpm -ql --licensefiles -p ./results_python-formulaic/0.5.2/3.fc38/python3-formulaic-0.5.2-3.fc38.noarch.rpm 
/usr/lib/python3.11/site-packages/formulaic-0.5.2.dist-info/licenses/LICENSE

 
> -) I read the comments on the disabled tests and the upstream thread. I saw
> they were just recently fixed here:
> https://github.com/matthewwardrop/formulaic/commit/
> e5dedcb0feed39f5ff6e2326d727ca65d247f26d
> Would it be worth to add this patch (to be removed at next package update)
> so then we can run all the tests probably?

Yeh, I've backported that now, and all tests are enabled.

Updated spec/srpm:

https://ankursinha.fedorapeople.org/python-formulaic/python-formulaic.spec
https://ankursinha.fedorapeople.org/python-formulaic/python-formulaic-0.5.2-3.fc38.src.rpm

Thanks again,

Ankur

Comment 4 fedepell 2022-11-09 14:08:56 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "MIT License", "Unknown or generated", "*No copyright*
     [generated file]". 109 files have unknown license. Detailed output of
     licensecheck in /home/feoo/2140295-python-formulaic/licensecheck.txt
[x]: Package contains no bundled libraries without FPC exception.
[-]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[-]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[-]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Packages MUST NOT have dependencies (either build-time or runtime) on
     packages named with the unversioned python- prefix unless no properly
     versioned package exists. Dependencies on Python packages instead MUST
     use names beginning with python2- or python3- as appropriate.
[x]: Python packages must not contain %{pythonX_site(lib|arch)}/* in %files
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[-]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[?]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Spec file according to URL is the same as in SRPM.
     Note: Spec file as given by url is not the same as in SRPM (see
     attached diff), but only due to automatic changelog generation.
     See: (this test has no URL)
[x]: Rpmlint is run on all installed packages.
     Note: No rpmlint messages.


Rpmlint
-------
Cannot parse rpmlint output:


Rpmlint (installed packages)
----------------------------
============================ rpmlint session starts ============================
rpmlint: 2.4.0
configuration:
    /usr/lib/python3.11/site-packages/rpmlint/configdefaults.toml
    /etc/xdg/rpmlint/fedora-legacy-licenses.toml
    /etc/xdg/rpmlint/fedora-spdx-licenses.toml
    /etc/xdg/rpmlint/fedora.toml
    /etc/xdg/rpmlint/scoring.toml
    /etc/xdg/rpmlint/users-groups.toml
    /etc/xdg/rpmlint/warn-on-functions.toml
checks: 31, packages: 1

 1 packages and 0 specfiles checked; 0 errors, 0 warnings, 0 badness; has taken 0.1 s 



Source checksums
----------------
https://github.com/matthewwardrop/formulaic/archive/v0.5.2/python-formulaic-0.5.2.tar.gz :
  CHECKSUM(SHA256) this package     : eeb4e88db7fdb38d6cbe698fbaad49b52d09282f3ed9d10df597331a69c9f50a
  CHECKSUM(SHA256) upstream package : eeb4e88db7fdb38d6cbe698fbaad49b52d09282f3ed9d10df597331a69c9f50a


Requires
--------
python3-formulaic (rpmlib, GLIBC filtered):
    python(abi)
    python3.11dist(astor)
    python3.11dist(interface-meta)
    python3.11dist(numpy)
    python3.11dist(pandas)
    python3.11dist(scipy)
    python3.11dist(typing-extensions)
    python3.11dist(wrapt)



Provides
--------
python3-formulaic:
    python-formulaic
    python3-formulaic
    python3.11-formulaic
    python3.11dist(formulaic)
    python3dist(formulaic)



Diff spec file in url and in SRPM
---------------------------------
--- /home/foo/2140295-python-formulaic/srpm/python-formulaic.spec	2022-11-09 14:50:12.201405900 +0100
+++ /home/foo/2140295-python-formulaic/srpm-unpacked/python-formulaic.spec	2022-11-09 12:28:58.000000000 +0100
@@ -1,2 +1,11 @@
+## START: Set by rpmautospec
+## (rpmautospec version 0.3.0)
+%define autorelease(e:s:pb:n) %{?-p:0.}%{lua:
+    release_number = 3;
+    base_release_number = tonumber(rpm.expand("%{?-b*}%{!?-b:1}"));
+    print(release_number + base_release_number - 1);
+}%{?-e:.%{-e*}}%{?-s:.%{-s*}}%{!?-n:%{?dist}}
+## END: Set by rpmautospec
+
 %global _description %{expand:
 Formulaic is a high-performance implementation of Wilkinson formulas for
@@ -68,3 +77,10 @@
 
 %changelog
-%autochangelog
+* Wed Nov 09 2022 Ankur Sinha (Ankur Sinha Gmail) <sanjay.ankur> 0.5.2-3
+- feat: backport patch to enable all tests
+
+* Sat Nov 05 2022 Ankur Sinha (Ankur Sinha Gmail) <sanjay.ankur> 0.5.2-2
+- feat: ready for review
+
+* Fri Nov 04 2022 Ankur Sinha (Ankur Sinha Gmail) <sanjay.ankur> 0.5.2-1
+- init


Generated by fedora-review 0.9.0 (6761b6c) last change: 2022-08-23
Command line :/usr/bin/fedora-review -b 2140295
Buildroot used: fedora-rawhide-x86_64
Active plugins: Generic, Shell-api, Python
Disabled plugins: Ocaml, Java, Perl, SugarActivity, PHP, R, fonts, Haskell, C/C++
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 5 Gwyn Ciesla 2022-11-09 18:49:45 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/python-formulaic